from datetime import datetime, timedelta

from discord.ext import commands
from discord.ext.tasks import loop
from discord.utils import find
from discord_slash import SlashContext


class CacheCog(commands.Cog):
    def __init__(self, bot: commands.Bot):
        self.bot = bot
        self.cache = {}
        self._expire_interaction.start()

    def check_cache(self, ctx: SlashContext, **kwargs):
        if not kwargs:
            kwargs = {}
        return find(
            lambda x: x["command"] == ctx.subcommand_name
            and x["user"] == ctx.author.id
            and x["guild"] == ctx.guild.id
            and all(x[k] == v for k, v in kwargs.items()),
            self.cache.values(),
        )

    @loop(minutes=1)
    async def _expire_interaction(self):
        keys = list(self.cache.keys())
        for key in keys:
            if self.cache[key]["timeout"] <= datetime.utcnow() + timedelta(
                minutes=1
            ):
                del self.cache[key]
